package com.sa.ibiz.demo.demo.rest;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.domain.TSSDTaskPolicy;
import com.sa.ibiz.demo.demo.service.TSSDTaskPolicyService;
import com.sa.ibiz.demo.demo.service.dto.TSSDTaskPolicySearchFilter;
import com.sa.ibiz.demo.ibizutil.errors.BadRequestAlertException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import java.math.BigInteger;
import java.util.List;

@RestController
@RequestMapping("/demo/tssdtaskpolicy")
public class TSSDTaskPolicyResource
{
	@Autowired
	private TSSDTaskPolicyService service;


	@PostMapping(value = "/create")
	public ResponseEntity<TSSDTaskPolicy> create(@Validated @RequestBody TSSDTaskPolicy data){
		boolean bRt=service.create(data);
		if(!bRt)
			throw new BadRequestAlertException("调度任务项策略[create]操作发生错误","TSSDTaskPolicy",data.getTssdtaskpolicyid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/getDraft")
	public ResponseEntity<TSSDTaskPolicy> getDraft(@Validated @RequestBody TSSDTaskPolicy data){
		boolean bRt=service.getDraft(data);
		if(!bRt)
			throw new BadRequestAlertException("调度任务项策略[getDraft]操作发生错误","TSSDTaskPolicy","");
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/remove")
	public ResponseEntity<TSSDTaskPolicy> remove(@Validated @RequestBody TSSDTaskPolicy data){
		boolean bRt=service.remove(data);
		if(!bRt)
			throw new BadRequestAlertException("调度任务项策略[remove]操作发生错误","TSSDTaskPolicy",data.getTssdtaskpolicyid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/update")
	public ResponseEntity<TSSDTaskPolicy> update(@Validated @RequestBody TSSDTaskPolicy data){
		boolean bRt=service.update(data);
		if(!bRt)
			throw new BadRequestAlertException("调度任务项策略[update]操作发生错误","TSSDTaskPolicy",data.getTssdtaskpolicyid().toString());
		return ResponseEntity.ok().body(data);
	}
	@GetMapping(value = "/{id}")
	public ResponseEntity<TSSDTaskPolicy> get(@Validated @PathVariable String id){
		TSSDTaskPolicy data=new TSSDTaskPolicy();
		data.setTssdtaskpolicyid(id);;
		data=service.get(data);
		if(data==null)
			throw new BadRequestAlertException("调度任务项策略[get]操作发生错误","TSSDTaskPolicy",id.toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/checkKey")
	public ResponseEntity<TSSDTaskPolicy> checkKey(@Validated @RequestBody TSSDTaskPolicy data){
		boolean bRt=service.checkKey(data);
		if(!bRt)
			throw new BadRequestAlertException("调度任务项策略[checkKey]操作发生错误","TSSDTaskPolicy",data.getTssdtaskpolicyid().toString());
		return ResponseEntity.ok().body(data);
	}
    @PostMapping(value="/searchdefault")
	public ResponseEntity<Page<TSSDTaskPolicy>> searchDefaultPage(@Validated @RequestBody TSSDTaskPolicySearchFilter filter){
		Page<TSSDTaskPolicy> searchResult = service.searchDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}

	@PostMapping(value="/listdefault")
	public ResponseEntity<List<TSSDTaskPolicy>> listDefault(@Validated @RequestBody TSSDTaskPolicySearchFilter filter){
		List<TSSDTaskPolicy> searchResult = service.listDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}
}
